% Exercise Sheet 10: Fundamental Limits
clear all;

% =============================================
% Simulation of the tank system
% =============================================
% Tank parameters
T1 = 3;
K1 = 0.03;
A = .1;


% =======================================
% Problem 30a
% =======================================
% Controller without integrator 

l0 = 1;
p0 = .5;
l1 = 0;
p1 = 0;
l2 = 0;
p2 = 0;
% reference step
r_step = 0.5; % water level of 0.5 m
d_step = 0;
ramp = 0;
options = simset('Solver','ode45');
sim('ECE441_Ex9_solution_simulink',[0,50],options);
figure(3);
plot(t,y);
legend('reference step $r = .5$\,m')
grid
xlabel('time [sec]')
ylabel('height [m]')
% disturbance step
r_step = 0;
d_step = .001;
sim('ECE441_Ex9_solution_simulink',[0,50],options);
figure(4);
plot(t,y);
legend('disturbance step $q_o = .001$m$^3$/sec')
grid
xlabel('time [sec]')
ylabel('position [m/s]')

% =======================================
% Problem 30b
% =======================================
% Controller with integrator 
u_loop = 1;
l0 = 0;
p0 = 1;
l1 = 2;
p1 = 10;
l2 = 0;
p2 = 0;
% Reference step
r_step = .5; % water level 0.5 m
d_step = 0;
options = simset('Solver','ode45');
sim('ECE441_Ex9_solution_simulink',[0,50],options);
figure(5);
plot(t,y);
legend('reference step $r = .5$\,m')
grid
xlabel('time [sec]')
ylabel('height [m]')
% disturbance step
r_step = 0;
d_step = .5;
sim('ECE441_Ex9_solution_simulink',[0,50],options);
figure(6);
plot(t,y);
legend('disturbance step $q_o = .001$m$^3$/sec')
grid
xlabel('time [sec]')
ylabel('height [m/s]')

% =======================================
% Problem 30c
% =======================================
% Controller with double integrator 
u_loop = 1;
l0 = 0;
p0 = 1;
l1 = 0;
p1 = 100;
l2 = 1000;
p2 = 2500;
% Reference Ramp
ramp = 1;
r_step = 0;
d_step = 0;
% simulation
options = simset('Solver','ode45');
sim('ECE441_Ex9_solution_simulink',[0,200],options);
figure(7);
plot(t,y);
legend('reference ramp $r = t')
grid
xlabel('time [sec]')
ylabel('height [m]')
% disturbance step
ramp = 0;
r_step = 0;
d_step = .001;
sim('ECE441_Ex9_solution_simulink',[0,200],options);
figure(8);
plot(t,y);
legend('disturbance step $q_o = .001$m$^3$/sec')
grid
xlabel('time [sec]')
ylabel('position [m/s]')

